package com.xkrs.sms;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.xkrs.model.entity.SysUserEntity;
import com.xkrs.utils.HttpClientUtils;
import com.xkrs.utils.SMSUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Component
public class SMSHelper {

    public static Logger log = LoggerFactory.getLogger(SMSHelper.class);

    public SMSHelper() {
    }

    public void dispatchSMSMessage(Map<String, List<SysUserEntity>> agentOrgNameGroupMap, String[] templateParamArray) {
        for (Map.Entry<String, List<SysUserEntity>> entry : agentOrgNameGroupMap.entrySet()) {
            String targetAgentOrgName = entry.getKey();
            List<SysUserEntity> groupSmsReceiverList = entry.getValue();
            if (groupSmsReceiverList != null && groupSmsReceiverList.size() > 0) {
                String[] telephoneArray = new String[groupSmsReceiverList.size()];
                for (int i = 0; i < groupSmsReceiverList.size(); i++) {
                    telephoneArray[i] = "86" + groupSmsReceiverList.get(i).getUserName();
                }
                if ("青岛星科瑞升信息科技有限公司".equals(targetAgentOrgName)) {

                    xkrsSendSmsToUser(telephoneArray, templateParamArray);

                } else if ("青岛华正信息技术股份有限公司".equals(targetAgentOrgName)) {

                    try {
                        huaZhengXinXi(telephoneArray, templateParamArray);
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }

            }
        }
    }

    /**
     * 星科瑞升向用户发送短信
     */
    private void xkrsSendSmsToUser(String[] telephoneArray, String[] templateParamArray) {
        SMSUtils.sendSmsToUser(telephoneArray, "1425995", templateParamArray);
        //记录短信通知日志
        StringBuilder stringBuilder = new StringBuilder("发送人：青岛星科瑞升信息科技有限公司\n");
        for (String telephone : telephoneArray) {
            stringBuilder.append("接收人：").append(telephone).append("\n");
        }
        for (String templateParam : templateParamArray) {
            stringBuilder.append("模板参数：").append(templateParam).append("\n");
        }
        log.info(stringBuilder.toString());
    }

    /**
     * 华正信息向用户发送短信
     */
    private void huaZhengXinXi(String[] telephoneArray, String[] templateParamArray) throws Exception {
        StringBuilder telephoneBuilder = new StringBuilder();
        for (int i = 0; i < telephoneArray.length; i++) {
            telephoneBuilder.append(telephoneArray[i]);
            if (i < telephoneArray.length - 1) {
                telephoneBuilder.append(",");
            }
        }
        String telephoneContent = telephoneBuilder.toString();
        String url = "http://58.56.128.186:10144/msg/msgReceive";
        Map<String, Object> map = new HashMap<>();
        map.put("receiver", telephoneContent);
        map.put("msgContent", "{\"content\":\"{'address':'" + templateParamArray[0] + "'}\"}");
        map.put("idType", "30");
        map.put("sendChannel", "30");
        map.put("sendAccount", "12");
        HttpClientUtils.sendHttpPost(url, new ObjectMapper().writeValueAsString(map));

        //记录短信通知日志
        StringBuilder stringBuilder = new StringBuilder("发送人：青岛华正信息技术股份有限公司\n");
        for (String telephone : telephoneArray) {
            stringBuilder.append("接收人：").append(telephone).append("\n");
        }
        for (String templateParam : templateParamArray) {
            stringBuilder.append("模板参数：").append(templateParam).append("\n");
        }
        log.info(stringBuilder.toString());
    }

}
